//****************************************************************************
//	aisa57w.pas
//
//	aISA-A57
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/08/03
//
//****************************************************************************

unit aisa57w;

interface

uses
	Windows;

{ őXbg }
const
	AISA57_MAX_SLOTS	= 16;

{ _Xbgw }
const
	AISA57_SLOT_AUTO	= Word(not 0);

{ G[R[h̒` }
const
	AISA57_ERR_INTERNAL				  = 5100;	{ Send mail to us }
	AISA57_ERR_UNKNOWN				  = 5101;	{ Help me! }
	AISA57_SUCCESS					    = 0;	  { I }
	AISA57_ERR_NO_DEVICE			  = 5000;	{ No device or not an aISA-A57 }
	AISA57_ERR_RESOURCE				  = 5001;	{ Resource exhaustion }
	AISA57_ERR_INVALID_ARG			= 5002;	{ Invalid argument(s) }
	AISA57_ERR_SLOT					    = 5003;	{ _Xbgԍsłi܂͌܂j }
	AISA57_ERR_CHANNEL				  = 5004;	{ `lw肪sł }
	AISA57_ERR_TIMER				    = 5005;	{ ^C}lsł }
	AISA57_ERR_NOT_ENOUGH_MEM	  = 5006;	{ \ȃmۂł܂ł }
	AISA57_ERR_NUMDATA				  = 5007;	{ w肳ꂽ̃f[^obt@ɑ݂܂ }
	AISA57_ERR_NOT_CREATED			= 5008;	{ foCXNGCgĂ܂ }
	AISA57_ERR_START				    = 5009;	{ X^[gɎs܂B}
	AISA57_ERR_INVALID_FUNC			= 5010;	{ Ȋ֐Ăяoł }
	AISA57_ERR_IN_USE				    = 5011;	{ gp̃foCXł(NT) }


const
	AISA57_BUFF_PCH_MAX = 4096;			{ 1ٓA/Dޯ̧MAX }

	AISA57_ADCH_MAX	 = 8;						{ A/Dِ }

{ TvO[h̒` }
const									{ START  SAMPLING	CLK }
	AISA57_MODE_01 = 1; { soft	 single	  --- }
	AISA57_MODE_02 = 2; { soft	 burst		timer }
  AISA57_MODE_03 = 3; { extrg  single	  --- }
  AISA57_MODE_04 = 4; { extrg  burst		timer }

{ bZ[W }
{ Aisa57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ }
{ ItZbglbZ[Wo܂B }
{$IFNDEF WM_EOC}
const
	WM_EOC							= 0; { VOTvO̊ }
	WM_BUFF_HALF_FULL		= 1; { Oobt@̃n[tt }
	WM_BUFF_FULL				= 2; { Oobt@̃t }
	WM_BUFF_OVERFLOW		= 3; { Oobt@̃I[o[t[ }
	WM_SAMPLING_OVERRUN = 4; { `lEI[gECNg̃I[o[ }
{$ENDIF}	{ WM_EOC }

{ A/D`lݒl͈̔ }
const
	AISA57_ADCH_FIRST   = 	0;
  AISA57_ADCH_LAST	  =   7;

{ A/D`lݒl }
const
	AISA57_ADCH_01		  =   0;
	AISA57_ADCH_02		  =   1;
  AISA57_ADCH_03		  =   2;
  AISA57_ADCH_04		  =   3;
  AISA57_ADCH_05		  =   4;
  AISA57_ADCH_06		  =   5;
  AISA57_ADCH_07		  =   6;
  AISA57_ADCH_08		  =   7;

{ D/A`lݒl }
const
	AISA57_DACH_01		  =   0;
  AISA57_DACH_02		  =   1;

{ I/O\[XzE }
const
	AISA57_MAX_MEM				    =  9; { MAX_MEM_REGISTERS }
	AISA57_MAX_IO					    = 20;	{ MAX_IO_PORTS }
  AISA57_MAX_IRQ					  =  7;	{ MAX_IRQS }
  AISA57_MAX_DMA					  =  7;	{ MAX_DMA_CHANNELS }

{ ***** I/O\[X\ ***** }
{ YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B }
type
	TAISA57RESOURCE = record
		dwNumMemWindows: DWord;																 { EBhE }
		dwMemBase:       array [1 .. AISA57_MAX_MEM] of DWord; { EBhEJnAhX }
		dwMemLength:     array [1 .. AISA57_MAX_MEM] of DWord; { EBhE }
		dwMemAttrib:     array [1 .. AISA57_MAX_MEM] of DWord; { EBhE }
		dwNumIOPorts:    DWord;																 { I/O|[g }
		dwIOPortBase:    array [1 .. AISA57_MAX_IO] of DWord;	 { I/O|[gJnAhX }
		dwIOPortLength:  array [1 .. AISA57_MAX_IO] of DWord;	 { I/O|[g }
		dwNumIRQs:       DWord;																 { IRQ }
		dwIRQRegisters:  array [1 .. AISA57_MAX_IRQ] of DWord; { IRQԍ }
		dwIRQAttrib:     array [1 .. AISA57_MAX_IRQ] of DWord; { IRQ }
		dwNumDMAs:       DWord;																 { DMA`l }
		dwDMALst:        array [1 .. AISA57_MAX_DMA] of DWord; { DMA`l }
		dwDMAAttrib:     array [1 .. AISA57_MAX_DMA] of DWord; { DMA`l }
		dwReserved1:     array [1 .. 3] of DWord;						   { \ }
	end;

PAISA57R = ^TAISA57RESOURCE;


{ ***** TvO[h\ ***** }
{ YfoCX̃TvO[hɊւDriver֓n߂̍\́B }
{ iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB }
type
	TAISA57MODE = record
		dwChFirst: DWord;		// TvOJn`l(0 ` 7)
		dwChLast:  DWord;		// TvOI`l(0 ` 7)
		cwBuffer:  DWord;		// obt@TCYi[hPʁj
		dwTimer:   DWord;		// ^C}l(00H ` 3FH)
		dwMode:    DWord;		// 샂[h(1 ` 4)
	end;

PAISA57M = ^TAISA57MODE;

type
	{ A/Dޯ̧ }
	TADBUFF = array [1..AISA57_ADCH_MAX, 1..AISA57_BUFF_PCH_MAX] of Word;
	TVXDBUFF = array [1..(AISA57_ADCH_MAX) * (AISA57_BUFF_PCH_MAX-1)] of Word;
	PADBUFF = ^TADBUFF;
	PVXDNUFF = ^TVXDBUFF;

const
	AISA57_ERR_WRAPDLL = DWord(-1); { bp[֐G[ }

const
	AISA57_DLL_NAME = 'aisa57.dll';	{ DLL }


function Aisa57wDllOpen: Boolean;		{ DLL [h }
function Aisa57wDllClose: Boolean;	{ DLL A[h }


{ foCXhCoDLL̃o[W擾 }
function Aisa57wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;


{ foCX̎gp錾 }
function Aisa57wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ foCX̊J錾 }
function Aisa57wClose(wLogSlot: Word): Boolean;


{ I/O\[X̎擾 }
function Aisa57wGetResource(wLogSlot: Word; pres: PAISA57R): Boolean;


{ TvO[h̐ݒ }
function Aisa57wSetMode(wLogSlot: Word; pcmode: PAISA57M): Boolean;
{ TvOJn }
function Aisa57wStartSampling(wLogSlot: Word): Boolean;
{ TvO~ }
function Aisa57wStopSampling(wLogSlot: Word): Boolean;
{ TvOEXe[^X̎擾 }
function Aisa57wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
{ TvOς݃f[^̎擾 }
function Aisa57wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;


{ D/Af[^o }
function Aisa57wSetData(wLogSlot: Word; wChData: Word; wDaData: Word): Boolean;


{ |[gf[^ }
function Aisa57wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
{ |[gփf[^o }
function Aisa57wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;


{ G[R[h̎擾 }
function Aisa57wGetLastError(wLogSlot: Word): DWord;



implementation

type
	TAisa57GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Bool; stdcall;
	TAisa57Create = function(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Bool; stdcall;
	TAisa57Close = function(wLogSlot: Word): Bool; stdcall;
	TAisa57GetResource = function(wLogSlot: Word; pres: PAISA57R): Bool; stdcall;
	TAisa57SetMode = function(wLogSlot: Word; pcmode: PAISA57M): Bool; stdcall;
	TAisa57StartSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa57StopSampling = function(wLogSlot: Word): Bool; stdcall;
	TAisa57GetSamplingStatus = function(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Bool; stdcall;
	TAisa57GetData = function(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Bool; stdcall;
	TAisa57SetData = function(wLogSlot: Word; wChData: Word; wDaData: Word): Bool; stdcall;
	TAisa57InPort = function(wLogSlot: Word; var pbInValue: Byte): Bool; stdcall;
	TAisa57OutPort = function(wLogSlot: Word; bOutValue: Byte): Bool; stdcall;
	TAisa57GetLastError = function(wLogSlot: Word): DWord; stdcall;

function Aisa57wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var
	pAisa57GetVersion: TAisa57GetVersion;
	pAisa57Create: TAisa57Create;
	pAisa57Close: TAisa57Close;
	pAisa57GetResource: TAisa57GetResource;
	pAisa57SetMode: TAisa57SetMode;
	pAisa57StartSampling: TAisa57StartSampling;
	pAisa57StopSampling: TAisa57StopSampling;
	pAisa57GetSamplingStatus: TAisa57GetSamplingStatus;
	pAisa57GetData: TAisa57GetData;
	pAisa57SetData: TAisa57SetData;
	pAisa57InPort: TAisa57InPort;
	pAisa57OutPort: TAisa57OutPort;
	pAisa57GetLastError: TAisa57GetLastError;


//****************************************************************************
// 		aisa57.dll[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wDllOpen: Boolean;
begin
	Result := False;

	if hDLL <> 0 then Exit;

	hDLL := LoadLibrary(AISA57_DLL_NAME);
	if hDLL = 0 then Exit;

	if Aisa57wGetDllExportFunc = False then
	begin
		Aisa57wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;

	Result := True;
end;

//****************************************************************************
// 		aisa57.dllA[h
// 		
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wDllClose: Boolean;
begin
	Result := True;

	if hDLL = 0 then Exit;

	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;



//****************************************************************************
// 		aISA-A57 DLL,Driver̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drivero[Wԍi[
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57GetVersion(pdwDllVer, pdwDrvVer);
end;

//****************************************************************************
// 		aISA-A57̔Cӂ̃foCX̎gp錾
// 		pwLogSlot	 gpfoCXi[
//				hWnd			 bZ[W𑗂EBhEnh
//				uWMBase		 ƂȂ郁bZ[WID
//				pvInitArg	 gp
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wCreate(var pwLogSlot: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
end;

//****************************************************************************
// 		aISA-A57̔Cӂ̃foCX̎gpJ
// 		wLogSlot gpfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wClose(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57Close(wLogSlot);
end;

//****************************************************************************
// 		wfoCX̃\[X擾
// 		wLogSlot ׂfoCX
//				pres		 \[Xi[\
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wGetResource(wLogSlot: Word; pres: PAISA57R): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57GetResource(wLogSlot, pres);
end;

//****************************************************************************
// 		TvO[h̐ݒ
// 		wLogSlot ݒ肷foCX
//				pcmode	 [hݒf[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wSetMode(wLogSlot: Word; pcmode: PAISA57M): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57SetMode(wLogSlot, pcmode);
end;

//****************************************************************************
// 		TvOJn
// 		wLogSlot JnfoCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wStartSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57StartSampling(wLogSlot);
end;

//****************************************************************************
// 		TvO~
// 		wLogSlot ~foCX
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wStopSampling(wLogSlot: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57StopSampling(wLogSlot);
end;

//****************************************************************************
// 		TvOEXe[^X̎擾
// 		wLogSlot	 擾foCX
//				pcwNumData f[^obt@AhX
//				pdwStatus	 Xe[^XAhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wGetSamplingStatus(wLogSlot: Word; var pcwNumData: DWord; var pdwStatus: DWord): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57GetSamplingStatus(wLogSlot, pcwNumData, pdwStatus);
end;

//****************************************************************************
// 		TvOς݃f[^̎擾
// 		wLogSlot	擾foCX
//				cwNumData vf[^
//				Data			f[^obt@ւ̃AhX
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wGetData(wLogSlot: Word; cwNumData: DWord; Data:PADBUFF): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57GetData(wLogSlot, cwNumData, Data);
end;

//****************************************************************************
// 	  D/Af[^o
// 	  wLogSlot _Xbg
//		  	wChData  ݃`l(0 ` 1)
//		  	wDaData  D/A݃f[^
// ߂l  True
//		  	s False
//****************************************************************************
function Aisa57wSetData(wLogSlot: Word; wChData: Word; wDaData: Word): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57SetData(wLogSlot, wChData, wDaData);
end;

//****************************************************************************
// 		|[gf[^
// 		wLogSlot	͂foCX
//				pbInValue ̓f[^i[
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wInPort(wLogSlot: Word; var pbInValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57InPort(wLogSlot, pbInValue);
end;

//****************************************************************************
// 		|[gփf[^o
// 		wLogSlot	o͂foCX
//				bOutValue o͂f[^
// ߂l  True
//				s False
//****************************************************************************
function Aisa57wOutPort(wLogSlot: Word; bOutValue: Byte): Boolean;
begin
	Result := False;

	if hDLL = 0 then Exit;

	Result := pAisa57OutPort(wLogSlot, bOutValue);
end;

//****************************************************************************
// 		aISA-A57̃G[R[h
// 		wLogSlot	G[foCX
// ߂l G[R[h
//****************************************************************************
function Aisa57wGetLastError(wLogSlot: Word): DWord;
begin
	Result := AISA57_ERR_WRAPDLL;

	if hDLL = 0 then Exit;

	Result := pAisa57GetLastError(wLogSlot);
end;

//---------------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//---------------------------------------------------------------------------
function Aisa57wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Aisa57GetVersion ̃AhX擾
	pAisa57GetVersion := GetProcAddress(hDLL, 'Aisa57GetVersion');
	if @pAisa57GetVersion = nil then Exit;

	// Aisa57Create ̃AhX擾
	pAisa57Create := GetProcAddress(hDLL, 'Aisa57Create');
	if @pAisa57Create = nil then Exit;

	// Aisa57Close ̃AhX擾
	pAisa57Close := GetProcAddress(hDLL, 'Aisa57Close');
	if @pAisa57Close = nil then Exit;

	// Aisa57GetResource ̃AhX擾
	pAisa57GetResource := GetProcAddress(hDLL, 'Aisa57GetResource');
	if @pAisa57GetResource = nil then Exit;

	// Aisa57SetMode ̃AhX擾
	pAisa57SetMode := GetProcAddress(hDLL, 'Aisa57SetMode');
	if @pAisa57SetMode = nil then Exit;

	// Aisa57StartSampling ̃AhX擾
	pAisa57StartSampling := GetProcAddress(hDLL, 'Aisa57StartSampling');
	if @pAisa57StartSampling = nil then Exit;

	// Aisa57StopSampling ̃AhX擾
	pAisa57StopSampling := GetProcAddress(hDLL, 'Aisa57StopSampling');
	if @pAisa57StopSampling = nil then Exit;

	// Aisa57GetSamplingStatus ̃AhX擾
	pAisa57GetSamplingStatus := GetProcAddress(hDLL, 'Aisa57GetSamplingStatus');
	if @pAisa57GetSamplingStatus = nil then Exit;

	// Aisa57GetData ̃AhX擾
	pAisa57GetData := GetProcAddress(hDLL, 'Aisa57GetData');
	if @pAisa57GetData = nil then Exit;

	// Aisa57SetData ̃AhX擾
	pAisa57SetData := GetProcAddress(hDLL, 'Aisa57SetData');
	if @pAisa57SetData = nil then Exit;

  // Aisa57InPort ̃AhX擾
	pAisa57InPort := GetProcAddress(hDLL, 'Aisa57InPort');
  if @pAisa57InPort = nil then Exit;

	// Aisa57OutPort ̃AhX擾
	pAisa57OutPort := GetProcAddress(hDLL, 'Aisa57OutPort');
	if @pAisa57OutPort = nil then Exit;

	// Aisa57GetLastError ̃AhX擾
	pAisa57GetLastError := GetProcAddress(hDLL, 'Aisa57GetLastError');
	if @pAisa57GetLastError = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

