#ifndef _AISA57_H_
#define _AISA57_H_

#ifdef __cplusplus
extern "C" {
#endif

// őXbg
#define	AISA57_MAX_SLOTS				16

// _Xbgw
#define	AISA57_SLOT_AUTO				((WORD) ~0U)

// G[R[h̒`
#define	AISA57_ERR_INTERNAL				5100	// Send mail to us
#define	AISA57_ERR_UNKNOWN				5101	// Help me!
#define	AISA57_SUCCESS					0		// I
#define	AISA57_ERR_NO_DEVICE			5000	// No device or not an aISA-A57
#define	AISA57_ERR_RESOURCE				5001	// Resource exhaustion
#define	AISA57_ERR_INVALID_ARG			5002	// Invalid argument(s)
#define	AISA57_ERR_SLOT					5003	// _Xbgԍsłi܂͌܂j
#define	AISA57_ERR_CHANNEL				5004	// `lw肪sł
#define	AISA57_ERR_TIMER				5005	// ^C}lsł
#define	AISA57_ERR_NOT_ENOUGH_MEM		5006	// \ȃmۂł܂ł
#define	AISA57_ERR_NUMDATA				5007	// w肳ꂽ̃f[^obt@ɑ݂܂
#define	AISA57_ERR_NOT_CREATED			5008	// foCXNGCgĂ܂
#define	AISA57_ERR_START				5009	// X^[gɎs܂B
#define	AISA57_ERR_INVALID_FUNC			5010	// Ȋ֐Ăяoł
#define	AISA57_ERR_IN_USE				5011	// gp̃foCXł(NT)

// TvO[h̒`
											// START  SAMPLING	CLK
#define	AISA57_MODE_01					1	// soft	  single	---
#define	AISA57_MODE_02					2	// soft	  burst		timer
#define	AISA57_MODE_03					3	// extrg  single	---
#define	AISA57_MODE_04					4	// extrg  burst		timer

// bZ[W
// Aisa57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
// ItZbglbZ[Wo܂B
#ifndef WM_EOC
#define	WM_EOC						0		// VOTvO̊
#define	WM_BUFF_HALF_FULL			1		// hCoOobt@̃n[tt
#define	WM_BUFF_FULL				2		// hCoOobt@̃t
#define	WM_BUFF_OVERFLOW			3		// hCoOobt@̃I[o[t[
#define	WM_SAMPLING_OVERRUN			4		// `lEI[gECNg̃I[o[
#endif // WM_EOC

// A/D`lݒl͈̔
#define AISA57_ADCH_FIRST	0
#define AISA57_ADCH_LAST	7

// A/D`lݒl
#define AISA57_ADCH_01		0
#define AISA57_ADCH_02		1
#define AISA57_ADCH_03		2
#define AISA57_ADCH_04		3
#define AISA57_ADCH_05		4
#define AISA57_ADCH_06		5
#define AISA57_ADCH_07		6
#define AISA57_ADCH_08		7

// D/A`lݒl
#define AISA57_DACH_01		0
#define AISA57_DACH_02		1

// I/O\[XzE
#define	AISA57_MAX_MEM					9	// MAX_MEM_REGISTERS
#define	AISA57_MAX_IO					20	// MAX_IO_PORTS
#define	AISA57_MAX_IRQ					7	// MAX_IRQS
#define	AISA57_MAX_DMA					7	// MAX_DMA_CHANNELS

// ***** I/O\[X\ *****
// YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
typedef struct _AISA57RESOURCE
{
	DWORD	dwNumMemWindows;					// EBhE
	DWORD	dwMemBase[AISA57_MAX_MEM];			// EBhEJnAhX
	DWORD	dwMemLength[AISA57_MAX_MEM];		// EBhE
	DWORD	dwMemAttrib[AISA57_MAX_MEM];		// EBhE
	DWORD	dwNumIOPorts;						// I/O|[g
	DWORD	dwIOPortBase[AISA57_MAX_IO];		// I/O|[gJnAhX
	DWORD	dwIOPortLength[AISA57_MAX_IO];		// I/O|[g
	DWORD	dwNumIRQs;							// IRQ
	DWORD	dwIRQRegisters[AISA57_MAX_IRQ];		// IRQԍ
	DWORD	dwIRQAttrib[AISA57_MAX_IRQ];		// IRQ
	DWORD	dwNumDMAs;							// DMA`l
	DWORD	dwDMALst[AISA57_MAX_DMA];			// DMA`l
	DWORD	dwDMAAttrib[AISA57_MAX_DMA];		// DMA`l
	DWORD	dwReserved1[3];						// \
} AISA57RESOURCE, *PAISA57R;


// ***** TvO[h\ *****
// YfoCX̃TvO[hɊւDriver֓n߂̍\́B
// iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
typedef struct _AISA57MODE
{
	DWORD	dwChFirst;		// TvOJn`l(0 ` 7)
	DWORD	dwChLast;		// TvOI`l(0 ` 7)
	DWORD	cwBuffer;		// obt@TCYi[hPʁj
	DWORD	dwTimer;		// ^C}l(00H ` 3FH)
	DWORD	dwMode;			// 샂[h(1 ` 4)
} AISA57MODE, *PCAISA57M;


// foCX̎gp錾
BOOL
WINAPI
Aisa57Create(
	LPWORD		lpwLogSlot,				// _Xbgw
	HWND		hwnd,					// bZ[W󂯎EBhEnh
	UINT		uWMBase,				// bZ[WID̊l
	LPVOID		lpvInitArg);			// ̂߂̗\


// foCX̊J錾
BOOL
WINAPI
Aisa57Close(
	WORD		wLogSlot);				// _Xbgw


// foCXhCoDLL̃o[W擾
BOOL
WINAPI
Aisa57GetVersion(
	LPDWORD		lpdwDllVer,				// DLL̃o[W
	LPDWORD		lpdwDrvVer);			// Driver̃o[W


// I/O\[X̎擾
BOOL
WINAPI
Aisa57GetResource(
	WORD		wLogSlot,				// _Xbg
	PAISA57R	pres);					// \[X


// G[R[h̎擾
DWORD
WINAPI
Aisa57GetLastError(
	WORD		wLogSlot);				// _Xbg


// TvO[h̐ݒ
BOOL
WINAPI
Aisa57SetMode(
	WORD		wLogSlot,				// _Xbg
	PCAISA57M	pcmode);				// [hݒf[^


// TvOJn
BOOL
WINAPI
Aisa57StartSampling(
	WORD		wLogSlot);				// _Xbg


// TvO~
BOOL
WINAPI
Aisa57StopSampling(
	WORD		wLogSlot);				// _Xbg


// TvOEXe[^X̎擾
BOOL
WINAPI
Aisa57GetSamplingStatus(
	WORD		wLogSlot,				// _Xbg
	LPDWORD		lpcwNumData,			// f[^obt@|C^
	LPDWORD		lpdwStatus);			// Xe[^X


// TvOς݃f[^̎擾
BOOL
WINAPI
Aisa57GetData(
	WORD		wLogSlot,				// _Xbg
	DWORD		cwNumData,				// vf[^
	LPWORD		lpwData);				// f[^obt@ւ̃|C^


// D/Af[^̏o
BOOL
WINAPI
Aisa57SetData(
	WORD		wLogSlot,				// _Xbg
	WORD		wChData,				// o̓`l
	WORD		wDaData);				// o̓f[^ւ̃|C^


// p
BOOL
WINAPI
Aisa57InPort(
	WORD		wLogSlot,				// _Xbg
	LPBYTE		lpbInValue);			// p̓f[^ւ̃|C^


// po
BOOL
WINAPI
Aisa57OutPort(
	WORD		wLogSlot,				// _Xbg
	BYTE		bOutValue);				// po̓f[^


#ifdef __cplusplus
}
#endif

#endif
