/******************************************************************************/
/*	aisa57s.c																  */
/*																			  */
/*	aISA-A57Tv\[X													  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/08/03															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "aisa57w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szA57[]	 = _T("aISA-A57");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024], szTmp[20];
	DWORD dwDLLVer, dwDrvVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// foCXi[
	AISA57RESOURCE ri;				// \[X
	AISA57MODE	   md;				// TvO[h
	DWORD dwNumData;
	DWORD dwStatus;
	PWORD pwData;
	WORD  wDaData;					// D/Af[^
	BYTE  InValue, OutValue;		// PIOf[^
	LONG  i;

/*---------------------------------------------------------------------------*/
	// aisa57.dll ̎gp錾
	if (Aisa57wDllOpen() == FALSE)
	{
		ErrorMessage(AISA57_SLOT_AUTO);
		return 1;			// aisa57.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// aISA-A57 DLL,Driver̃o[Wԍ擾
	if (Aisa57wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(AISA57_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"),
					dwDLLVer,
					dwDrvVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-A57̎gp錾
	wLogSlot = AISA57_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa57wCreate(&wLogSlot,	// ꍇA̎̃foCXi[܂B
							NULL,		// EBhEnhȂ̂NULLZbg܂B
										// EBhEnhZbg΁A
										// e탁bZ[W܂B
							0x6401,		// 3ԖڂɃZbgẮAbZ[WID̊
										// ƂȂlłBۂ̃bZ[WID͂̊lɃI
										// tZbg(WM_EOCȂ)̂ƂȂ܂B
							NULL);

	if (bResult == FALSE)		// foCX܂B
	{
		ErrorMessage(AISA57_SLOT_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-A57 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Aisa57wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n")
					_T("IRQ: %2d"),
					szA57,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0]);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
/*	A/D 																 */
/*---------------------------------------------------------------------------*/
	// TvO[h̐ݒ
	md.dwChFirst = 0;				// TvOJn`l(0 ` 7)
	md.dwChLast	= 7;				// TvOI`l(0 ` 7)
	md.cwBuffer = 256;				// obt@TCYi[hPʁj
	md.dwTimer	= 0x27;				// ^C}l({[h}jAP.27Q)
	md.dwMode	= AISA57_MODE_02;	// 샂[h(1`4)

	if (Aisa57wSetMode(wLogSlot, &md) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("aISA-A57 Sampling Mode\n")
					_T("TvOJn`l=%ld\n")
					_T("TvOI`l=%ld\n")
					_T("obt@TCY=%ld\n")
					_T("^C}l=%02xh\n")
					_T("샂[h=%ld"),
					md.dwChFirst, md.dwChLast, md.cwBuffer, md.dwTimer, md.dwMode);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOJn
	if (Aisa57wStartSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A57 Sampling Started"));

/*---------------------------------------------------------------------------*/
	// TvO~
	if (Aisa57wStopSampling(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A57 Sampling Stopped"));

/*---------------------------------------------------------------------------*/
	// TvOEXe[^X̎擾
	if (Aisa57wGetSamplingStatus(wLogSlot, &dwNumData, &dwStatus) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("TvOEXe[^X擾\n")
					_T("f[^=%ld\n")
					_T("Xe[^X=%ld"),
					dwNumData, dwStatus);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOς݃f[^̎擾
	if (dwNumData)
	{
		pwData = (PWORD)malloc(dwNumData * sizeof(WORD));
		memset(pwData, 0, dwNumData * sizeof(WORD));

		if (Aisa57wGetData(wLogSlot, dwNumData, pwData) == FALSE)
		{
			ErrorMessage(wLogSlot);
			return 1;
		}

		wsprintf(szbuf, _T("TvOς݃f[^擾\n"));
		for (i = 0; i < (LONG)dwNumData && lstrlen(szbuf) < sizeof(szbuf) - sizeof(szTmp) ; i++)
		{
			wsprintf(szTmp, _T("%ld:%lxh  "), i, pwData[i]);

			strcat(szbuf, szTmp);

			if ((i + 1) % 4 == 0)	// 4 Ŋ؂
				strcat(szbuf, _T("\n"));
		}

		ResultMessage(szbuf);

		free(pwData);
	}

/*---------------------------------------------------------------------------*/
/*	D/A 																 */
/*---------------------------------------------------------------------------*/
	// o̓f[^̐ݒ
	wDaData = 0x0FFF;

	if (Aisa57wSetData(wLogSlot, AISA57_DACH_01, wDaData) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("D/Af[^o\n")
					_T("D/A Data: %03xh"),
					 wDaData);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
/*	PIO 																 */
/*---------------------------------------------------------------------------*/
	// Cӂ̃f[^o
	// o̓f[^ AAh
	OutValue = (BYTE)0xAA;

	if (Aisa57wOutPort(wLogSlot, OutValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("f[^o\n")
					_T("Out Data: %02xh"),
					 OutValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// f[^ǂݍ
	InValue = (BYTE)0x00;

	if (Aisa57wInPort(wLogSlot, &InValue) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szbuf, _T("f[^\n")
					_T("In Data: %02xh"),
					 InValue);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// aISA-A57̎gpJ
	if (Aisa57wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	ResultMessage(_T("aISA-A57 Closed"));

/*---------------------------------------------------------------------------*/
	// aisa57.dll ̎gpJ
	if (Aisa57wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL Unload error"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// aisa57.dll ̃A[hɎs܂B
	}

	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa57wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AISA57_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-A57 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
