/*****************************************************************************/
/*	aisa57w.c																 */
/*																			 */
/*	aISA-A57															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/07/10															 */
/*																			 */
/*****************************************************************************/

#define STRICT

#include <windows.h>
#include <tchar.h>

#include "aisa57w.h"	// aISA-A57

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Aisa57wGetDllExportFunc();

/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAisa57GetVersion;
static FARPROC pAisa57Create;
static FARPROC pAisa57Close;
static FARPROC pAisa57GetResource;
static FARPROC pAisa57SetMode;
static FARPROC pAisa57StartSampling;
static FARPROC pAisa57StopSampling;
static FARPROC pAisa57GetSamplingStatus;
static FARPROC pAisa57GetData;
static FARPROC pAisa57SetData;
static FARPROC pAisa57InPort;
static FARPROC pAisa57OutPort;
static FARPROC pAisa57GetLastError;


/*****************************************************************************/
/* 	  aisa57.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(AISA57_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Aisa57wGetDllExportFunc() == FALSE)
	{
		Aisa57wDllClose();	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}

	return TRUE;
}

/*****************************************************************************/
/* 	  aisa57.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

/*****************************************************************************/
/* 	  aISA-A57 DLL,Driver̃o[Wԍ擾							 */
/* 	  pdwDllVer DLLo[Wԍi[AhX						 */
/*		  pdwDrvVer Drivero[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57GetVersion)(pdwDllVer, pdwDrvVer);
}

/*****************************************************************************/
/* 	  aISA-A57̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSlot gpfoCXi[AhX						 */
/*		  hWnd		bZ[W𑗂EBhEnh						 */
/*		  uWMBase	ƂȂ郁bZ[WID									 */
/*		  pvInitArg gp(NULLZbg)									 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57Create)(pwLogSlot, hWnd, uWMBase, pvInitArg);
}

/*****************************************************************************/
/* 	  aISA-A57̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSlot gpfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57Close)(wLogSlot);
}

/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSlot ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wGetResource(WORD wLogSlot, PAISA57R pres)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57GetResource)(wLogSlot, pres);
}

/*****************************************************************************/
/* 	  TvO[h̐ݒ											 */
/* 	  wLogSlot ݒ肷foCX											 */
/*		  pcmode   [hݒf[^̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wSetMode(WORD wLogSlot, PCAISA57M pcmode)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57SetMode)(wLogSlot, pcmode);
}

/*****************************************************************************/
/* 	  TvOJn													 */
/* 	  wLogSlot JnfoCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wStartSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57StartSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvO~													 */
/* 	  wLogSlot ~foCX											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wStopSampling(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57StopSampling)(wLogSlot);
}

/*****************************************************************************/
/* 	  TvOEXe[^X̎擾									 */
/* 	  wLogSlot	 擾foCX										 */
/*		  pcwNumData f[^obt@AhX								 */
/*		  pdwStatus	 Xe[^XAhX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wGetSamplingStatus(WORD wLogSlot, PDWORD pcwNumData, PDWORD pdwStatus)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57GetSamplingStatus)(wLogSlot, pcwNumData, pdwStatus);
}

/*****************************************************************************/
/* 	  TvOς݃f[^̎擾										 */
/* 	  wLogSlot	擾foCX										 */
/*		  cwNumData vf[^											 */
/*		  pwData	f[^obt@ւ̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wGetData(WORD wLogSlot, DWORD cwNumData, PWORD pwData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57GetData)(wLogSlot, cwNumData, pwData);
}

/*****************************************************************************/
/* 	  D/Af[^̏o													 */
/* 	  wLogSlot	o͂foCX										 */
/*		  wChData	݃`lw									 */
/*		  wDaData	o͂D/Af[^										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wSetData(WORD wLogSlot, WORD wChData, WORD wDaData)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57SetData)(wLogSlot, wChData, wDaData);
}
/*****************************************************************************/
/* 	  Cӂ̃|[gf[^										 */
/* 	  wLogSlot	͂foCX										 */
/*		  pbInValue ̓f[^i[AhX							 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wInPort(WORD wLogSlot, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57InPort)(wLogSlot, pbInValue);
}

/*****************************************************************************/
/* 	  Cӂ̃|[gփf[^o										 */
/* 	  wLogSlot	o͂foCX										 */
/*		  bOutValue o͂f[^											 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Aisa57wOutPort(WORD wLogSlot, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pAisa57OutPort)(wLogSlot, bOutValue);
}

/*****************************************************************************/
/* 	  aISA-A57̃G[R[h											 */
/* 	  wLogSlot	G[foCX								 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Aisa57wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL)
		return AISA57_ERR_WRAPDLL;

	return (*pAisa57GetLastError)(wLogSlot);
}

/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Aisa57wGetDllExportFunc()
{
	// Aisa57GetVersion ̃AhX擾
	pAisa57GetVersion = GetProcAddress(hDLL, _T("Aisa57GetVersion"));
	if (pAisa57GetVersion == NULL)
		return FALSE;

	// Aisa57Create ̃AhX擾
	pAisa57Create = GetProcAddress(hDLL, _T("Aisa57Create"));
	if (pAisa57Create == NULL)
		return FALSE;

	// Aisa57Close ̃AhX擾
	pAisa57Close = GetProcAddress(hDLL, _T("Aisa57Close"));
	if (pAisa57Close == NULL)
		return FALSE;

	// Aisa57GetResource ̃AhX擾
	pAisa57GetResource = GetProcAddress(hDLL, _T("Aisa57GetResource"));
	if (pAisa57GetResource == NULL)
		return FALSE;

	// Aisa57SetMode ̃AhX擾
	pAisa57SetMode = GetProcAddress(hDLL, _T("Aisa57SetMode"));
	if (pAisa57SetMode == NULL)
		return FALSE;

	// Aisa57StartSampling ̃AhX擾
	pAisa57StartSampling = GetProcAddress(hDLL, _T("Aisa57StartSampling"));
	if (pAisa57StartSampling == NULL)
		return FALSE;

	// Aisa57StopSampling ̃AhX擾
	pAisa57StopSampling = GetProcAddress(hDLL, _T("Aisa57StopSampling"));
	if (pAisa57StopSampling == NULL)
		return FALSE;

	// Aisa57GetSamplingStatus ̃AhX擾
	pAisa57GetSamplingStatus = GetProcAddress(hDLL, _T("Aisa57GetSamplingStatus"));
	if (pAisa57GetSamplingStatus == NULL)
		return FALSE;

	// Aisa57GetData ̃AhX擾
	pAisa57GetData = GetProcAddress(hDLL, _T("Aisa57GetData"));
	if (pAisa57GetData == NULL)
		return FALSE;

	// Aisa57SetData ̃AhX擾
	pAisa57SetData = GetProcAddress(hDLL, _T("Aisa57SetData"));
	if (pAisa57SetData == NULL)
		return FALSE;

	// Aisa57InPort ̃AhX擾
	pAisa57InPort = GetProcAddress(hDLL, _T("Aisa57InPort"));
	if (pAisa57InPort == NULL)
		return FALSE;

	// Aisa57OutPort ̃AhX擾
	pAisa57OutPort = GetProcAddress(hDLL, _T("Aisa57OutPort"));
	if (pAisa57OutPort == NULL)
		return FALSE;

	// Aisa57GetLastError ̃AhX擾
	pAisa57GetLastError = GetProcAddress(hDLL, _T("Aisa57GetLastError"));
	if (pAisa57GetLastError == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
